/*
 * Proyecto: Basic reports
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 22/10/2004
 */

#include "Xailer.ch"
#include "report.ch"

CLASS TFrm1 FROM TForm

   COMPONENT oCdxDataSource1
   COMPONENT oDataSet
   COMPONENT oButton1
   COMPONENT oButton2
   COMPONENT oButton3
   COMPONENT oButton4
   COMPONENT oButton5
   COMPONENT oButton6
   COMPONENT oButton7
   COMPONENT oButton8
   COMPONENT oButton9
   COMPONENT oButton10
   COMPONENT oButton11

   METHOD CreateForm()
   METHOD Button1Click( oSender )
   METHOD Button2Click( oSender )
   METHOD Button3Click( oSender )
   METHOD Button4Click( oSender )
   METHOD Button5Click( oSender )
   METHOD Button6Click( oSender )
   METHOD Button7Click( oSender )
   METHOD Button8Click( oSender )
   METHOD Button9Click( oSender )
   METHOD Button10Click( oSender )
   METHOD FormInitialize( oSender )
   METHOD Button11Click( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TFrm1

   // PDF Export from Print Preview:
   // "http://www.utilitywarrior.com/Image-to-PDF-Dynamic-Link-Library.htm"

   WITH OBJECT Printer:oExportInfo
      :cImgPDFLicense := ""
      :lImgPDFButton  := .T.
      :lMailButton    := .T.
   END WITH

RETURN Nil


//------------------------------------------------------------------------------

METHOD Button1Click( oSender ) CLASS TFrm1

   Local oReport, oFont1, oFont2

  With Object oFont1 := TFont():New()
   :cName := "Arial"
   :nSize := 12
   :lBold := .T.
  END WITH

  With Object oFont2 := TFont():New()
   :cName := "Arial"
   :nSize := 10
   :lBold := .f.
  END WITH

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW ;
      FONT oFont1, oFont2

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT ;
      FONT 2

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	RUN REPORT oReport

   oFont1:Destroy()
   oFont2:Destroy()

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button2Click( oSender ) CLASS TFrm1

   Local oReport

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW MODAL

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Street" ;
		DATA Customer->Street

	COLUMN OF oReport ;
		TITLE "City" ;
		DATA Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button3Click( oSender ) CLASS TFrm1

   Local oReport

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First", "Last" ;
		DATA Customer->First, Customer->Last

	COLUMN OF oReport ;
		TITLE "Street", "City" ;
		DATA Customer->Street, Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button4Click( oSender ) CLASS TFrm1

   Local oReport

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      HEADER DtoC( Date() ) + " " + Time() ;
      FOOTER "Page: " + lTrim( Str( oReport:nPage ) ) ALIGN taCENTER ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First", "Last" ;
		DATA Customer->First, Customer->Last

	COLUMN OF oReport ;
		TITLE "Street", "City" ;
		DATA Customer->Street, Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button5Click( oSender ) CLASS TFrm1

   Local oReport, oGroup

   ::oDataSet:OrdSetFocus( "First" )
   ::oDataSet:Gotop()


	REPORT oReport ;
      TITLE "My first Xailer report" ;
      HEADER DtoC( Date() ) + " " + Time() ;
      FOOTER "Page: " + lTrim( Str( oReport:nPage ) ) ALIGN taCENTER ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Street" ;
		DATA Customer->Street

	COLUMN OF oReport ;
		TITLE "City" ;
		DATA Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	GROUP oGroup OF oReport ;
      ON Upper( Left( Customer->First, 1 ) ) ;
      FOOTER "Letter " + oGroup:cValue + ":"

   RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button6Click( oSender ) CLASS TFrm1

   Local oReport, oGroup

   ::oDataSet:OrdSetFocus( "First" )
   ::oDataSet:Gotop()


	REPORT oReport ;
      TITLE "My first Xailer Summary report" ;
      PREVIEW ;
      SUMMARY


	COLUMN OF oReport ;
		TITLE "First (first letter)" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	GROUP oGroup OF oReport ;
      ON Upper( Left( Customer->First, 1 ) ) ;
      FOOTER "Letter " + oGroup:cValue + ":"

   RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button7Click( oSender ) CLASS TFrm1

   Local oReport

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	oReport:nGridStyle := rgVERTICAL

   RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button8Click( oSender ) CLASS TFrm1

   Local oReport

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999" ;
		TOTAL

	oReport:nTitleUpLine := rlNONE
   oReport:nGridStyle := rgBOTH

   RUN REPORT oReport

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button9Click( oSender ) CLASS TFrm1

   Local oReport, oBitmap

   oBitmap := TPicture():Load( "xailer" )

   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer report" ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "Recno" ;
		DATA Recno() ;
		ALIGN taRIGHT

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Street" ;
		DATA Customer->Street

	COLUMN OF oReport ;
		TITLE "City" ;
		DATA Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 99,999,999.99" ;
		TOTAL

	oReport:nTitleUpLine := rlNONE
   oReport:nGridStyle := rgBOTH

   RUN REPORT oReport ;
      ON STARTPAGE PrintBitmap( oReport, oBitmap )

   oBitmap:Destroy()

RETURN Nil

//------------------------------------------------------------------------------

STATIC FUNCTION PrintBitmap( oReport, oBitmap )

   LOCAL nMapMode

   WITH OBJECT oReport:oDevice:oCanvas
      nMapMode := :nMapMode
      :nMapMode := mmHIMETRICS
      :DrawPicture( {20, 20, 300, 262}, oBitmap )
      :nMapMode := nMapMode
   END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD Button10Click( oSender ) CLASS TFrm1

   Local oReport, oGroup

   ::oDataSet:OrdSetFocus( "First" )
   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer Report"

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Street" ;
		DATA Customer->Street

	COLUMN OF oReport ;
		TITLE "City" ;
		DATA Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 999,999,999,999.99" ;
		TOTAL

	GROUP oGroup OF oReport ;
      ON Upper( Left( Customer->First, 1 ) ) ;
      FOOTER "Letter " + oGroup:cValue + ":"

   oReport:ToExcel()

RETURN Nil

//------------------------------------------------------------------------------

METHOD Button11Click( oSender ) CLASS TFrm1

   Local oPrinter, oReport, oGroup, oFrm2

   ::oDataSet:OrdSetFocus( "First" )
   ::oDataSet:Gotop()

	REPORT oReport ;
      TITLE "My first Xailer Report" ;
      PREVIEW

	COLUMN OF oReport ;
		TITLE "First" ;
		DATA Customer->First

	COLUMN OF oReport ;
		TITLE "Last" ;
		DATA Customer->Last

	COLUMN OF oReport ;
		TITLE "Street" ;
		DATA Customer->Street

	COLUMN OF oReport ;
		TITLE "City" ;
		DATA Customer->City

	COLUMN OF oReport ;
		TITLE "Salary" ;
		DATA Customer->Salary ;
		ALIGN taRIGHT ;
		PICTURE "@E 999,999,999,999.99" ;
		TOTAL

	GROUP oGroup OF oReport ;
      ON Upper( Left( Customer->First, 1 ) ) ;
      FOOTER "Letter " + oGroup:cValue + ":"

   oFrm2 := TForm2():New( Self ):Create()

   Printer:OnPreview := { |nShowMode, lModal| oFrm2:Preview(nShowMode, lModal) }

   oReport:Run()

RETURN Nil

//------------------------------------------------------------------------------
